diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/internet/model/tcp-dctcp.h ns-3.32/src/internet/model/tcp-dctcp.h
--- ns-3.31/src/internet/model/tcp-dctcp.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/internet/model/tcp-dctcp.h	2020-10-06 15:35:43.000000000 -0700
@@ -29,8 +29,8 @@
 /**
  * \ingroup tcp
  *
- * \brief An implementation of DCTCP. This model implements all the functionalities mentioned
- * in the DCTCP SIGCOMM paper except dynamic buffer allocation in switches
+ * \brief An implementation of DCTCP. This model implements all of the
+ * endpoint capabilities mentioned in the DCTCP SIGCOMM paper.
  */
 
 class TcpDctcp : public TcpNewReno
@@ -58,11 +58,7 @@
    */
   virtual ~TcpDctcp (void);
 
-  /**
-   * \brief Get the name of the TCP flavour
-   *
-   * \return The name of the TCP
-   */
+  // Documented in base class
   virtual std::string GetName () const;
 
   /**
@@ -71,34 +67,15 @@
    *        either ECT(0) or ECT(1) (depending on the 'UseEct0' attribute),
    *        despite any other configuration in the base classes.
    *
-   * \param ecnMode ECN Mode
+   * \param tcb internal congestion state
    */
   virtual void Init (Ptr<TcpSocketState> tcb);
 
+  // Documented in base class
   virtual Ptr<TcpCongestionOps> Fork ();
-
-  /**
-   * \brief Reduce congestion window based on DCTCP algorithm
-   *
-   * \param tcb internal congestion state
-   */
   virtual void ReduceCwnd (Ptr<TcpSocketState> tcb);
-
-  /**
-   * \brief Get information from the acked packet
-   *
-   * \param tcb internal congestion state
-   * \param segmentsAcked count of segments ACKed
-   * \param rtt The estimated rtt
-   */
   virtual void PktsAcked (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked,
                           const Time &rtt);
-  /**
-   * \brief Trigger events/calculations on occurrence of congestion window event
-   *
-   * \param tcb internal state
-   * \param event congestion window event which triggered this function
-   */
   virtual void CwndEvent (Ptr<TcpSocketState> tcb,
                           const TcpSocketState::TcpCAEvent_t event);
 private:
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/internet/model/tcp-l4-protocol.cc ns-3.32/src/internet/model/tcp-l4-protocol.cc
--- ns-3.31/src/internet/model/tcp-l4-protocol.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/internet/model/tcp-l4-protocol.cc	2020-10-06 15:35:43.000000000 -0700
@@ -43,6 +43,7 @@
 #include "tcp-socket-base.h"
 #include "tcp-congestion-ops.h"
 #include "tcp-recovery-ops.h"
+#include "tcp-prr-recovery.h"
 #include "rtt-estimator.h"
 
 #include <vector>
@@ -83,7 +84,7 @@
                    MakeTypeIdChecker ())
     .AddAttribute ("RecoveryType",
                    "Recovery type of TCP objects.",
-                   TypeIdValue (TcpClassicRecovery::GetTypeId ()),
+                   TypeIdValue (TcpPrrRecovery::GetTypeId ()),
                    MakeTypeIdAccessor (&TcpL4Protocol::m_recoveryTypeId),
                    MakeTypeIdChecker ())
     .AddAttribute ("SocketList", "The list of sockets associated to this protocol.",
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/internet/model/tcp-linux-reno.cc ns-3.32/src/internet/model/tcp-linux-reno.cc
--- ns-3.31/src/internet/model/tcp-linux-reno.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/internet/model/tcp-linux-reno.cc	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,149 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2019 NITK Surathkal
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Apoorva Bhargava <apoorvabhargava13@gmail.com>
+ *         Mohit P. Tahiliani <tahiliani@nitk.edu.in>
+ *
+ */
+
+#include "tcp-linux-reno.h"
+#include "ns3/log.h"
+#include "ns3/simulator.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("TcpLinuxReno");
+NS_OBJECT_ENSURE_REGISTERED (TcpLinuxReno);
+
+TypeId
+TcpLinuxReno::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::TcpLinuxReno")
+    .SetParent<TcpCongestionOps> ()
+    .SetGroupName ("Internet")
+    .AddConstructor<TcpLinuxReno> ()
+  ;
+  return tid;
+}
+
+TcpLinuxReno::TcpLinuxReno (void) : TcpCongestionOps ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+TcpLinuxReno::TcpLinuxReno (const TcpLinuxReno& sock)
+  : TcpCongestionOps (sock)
+{
+  NS_LOG_FUNCTION (this);
+}
+
+TcpLinuxReno::~TcpLinuxReno (void)
+{
+}
+
+uint32_t
+TcpLinuxReno::SlowStart (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked)
+{
+  NS_LOG_FUNCTION (this << tcb << segmentsAcked);
+
+  if (segmentsAcked >= 1)
+    {
+      uint32_t sndCwnd = tcb->m_cWnd;
+      tcb->m_cWnd = std::min ((sndCwnd + (segmentsAcked * tcb->m_segmentSize)), (uint32_t)tcb->m_ssThresh);
+      NS_LOG_INFO ("In SlowStart, updated to cwnd " << tcb->m_cWnd << " ssthresh " << tcb->m_ssThresh);
+      return segmentsAcked - ((tcb->m_cWnd - sndCwnd) / tcb->m_segmentSize);
+    }
+
+  return 0;
+}
+
+void
+TcpLinuxReno::CongestionAvoidance (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked)
+{
+  NS_LOG_FUNCTION (this << tcb << segmentsAcked);
+
+  uint32_t w = tcb->m_cWnd / tcb->m_segmentSize;
+  NS_LOG_DEBUG ("w in segments " << w << " m_cWndCnt " << m_cWndCnt << " segments acked " << segmentsAcked);
+  if (m_cWndCnt >= w)
+    {
+      m_cWndCnt = 0;
+      tcb->m_cWnd += tcb->m_segmentSize;
+      NS_LOG_DEBUG ("Adding 1 segment to m_cWnd");
+    }
+
+  m_cWndCnt += segmentsAcked;
+  NS_LOG_DEBUG ("Adding 1 segment to m_cWndCnt");
+  if (m_cWndCnt >= w)
+    {
+      uint32_t delta = m_cWndCnt / w;
+
+      m_cWndCnt -= delta * w;
+      tcb->m_cWnd += delta * tcb->m_segmentSize;
+      NS_LOG_DEBUG ("Subtracting delta * w from m_cWndCnt " << delta * w);
+    }
+  NS_LOG_DEBUG ("At end of CongestionAvoidance(), m_cWnd: " << tcb->m_cWnd << " m_cWndCnt: " << m_cWndCnt);
+}
+
+void
+TcpLinuxReno::IncreaseWindow (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked)
+{
+  NS_LOG_FUNCTION (this << tcb << segmentsAcked);
+
+  // Linux tcp_in_slow_start() condition
+  if (tcb->m_cWnd < tcb->m_ssThresh)
+    {
+      NS_LOG_DEBUG ("In slow start, m_cWnd " << tcb->m_cWnd << " m_ssThresh " << tcb->m_ssThresh);
+      segmentsAcked = SlowStart (tcb, segmentsAcked);
+    }
+  else
+    {
+      NS_LOG_DEBUG ("In cong. avoidance, m_cWnd " << tcb->m_cWnd << " m_ssThresh " << tcb->m_ssThresh);
+      CongestionAvoidance (tcb, segmentsAcked);
+    }
+}
+
+std::string
+TcpLinuxReno::GetName () const
+{
+  return "TcpLinuxReno";
+}
+
+uint32_t
+TcpLinuxReno::GetSsThresh (Ptr<const TcpSocketState> state,
+                           uint32_t bytesInFlight)
+{
+  NS_LOG_FUNCTION (this << state << bytesInFlight);
+
+  // In Linux, it is written as:  return max(tp->snd_cwnd >> 1U, 2U);
+  return std::max<uint32_t> (2 * state->m_segmentSize, state->m_cWnd / 2);
+}
+
+void
+TcpLinuxReno::ReduceCwnd (Ptr<TcpSocketState> tcb)
+{
+  NS_LOG_FUNCTION (this << tcb);
+
+  tcb->m_cWnd = std::max ( tcb->m_cWnd.Get () / 2, tcb->m_segmentSize);
+}
+
+Ptr<TcpCongestionOps>
+TcpLinuxReno::Fork ()
+{
+  return CopyObject<TcpLinuxReno> (this);
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/internet/model/tcp-linux-reno.h ns-3.32/src/internet/model/tcp-linux-reno.h
--- ns-3.31/src/internet/model/tcp-linux-reno.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/internet/model/tcp-linux-reno.h	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,68 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2019 NITK Surathkal
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Apoorva Bharagava <apoorvabhargava13@gmail.com>
+ *         Mohit P. Tahiliani <tahiliani@nitk.edu.in>
+ *
+ */
+
+#ifndef TCPLINUXRENO_H
+#define TCPLINUXRENO_H
+
+#include "ns3/tcp-congestion-ops.h"
+#include "ns3/tcp-socket-state.h"
+
+namespace ns3 {
+
+class TcpLinuxReno : public TcpCongestionOps
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+
+  TcpLinuxReno ();
+
+  /**
+   * \brief Copy constructor.
+   * \param sock object to copy.
+   */
+  TcpLinuxReno (const TcpLinuxReno& sock);
+
+  ~TcpLinuxReno ();
+
+  std::string GetName () const;
+
+  virtual void IncreaseWindow (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked);
+  virtual uint32_t GetSsThresh (Ptr<const TcpSocketState> tcb,
+                                uint32_t bytesInFlight);
+  virtual void ReduceCwnd (Ptr<TcpSocketState> tcb);
+  virtual Ptr<TcpCongestionOps> Fork ();
+
+protected:
+  virtual uint32_t SlowStart (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked);
+  virtual void CongestionAvoidance (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked);
+
+private:
+  uint32_t m_cWndCnt {0}; //!< Linear increase counter
+};
+
+} // namespace ns3
+
+#endif // TCPLINUXRENO_H
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/internet/model/tcp-prr-recovery.cc ns-3.32/src/internet/model/tcp-prr-recovery.cc
--- ns-3.31/src/internet/model/tcp-prr-recovery.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/internet/model/tcp-prr-recovery.cc	2020-10-06 15:35:43.000000000 -0700
@@ -102,7 +102,14 @@
         }
       else if (m_reductionBoundMode == SSRB)
         {
-          limit = std::max (m_prrDelivered - m_prrOut, deliveredBytes) + tcb->m_segmentSize;
+          if (tcb->m_isRetransDataAcked)
+            {
+              limit = std::max (m_prrDelivered - m_prrOut, deliveredBytes) + tcb->m_segmentSize;
+            }
+          else
+            {
+              limit = deliveredBytes;
+            }
         }
       sendCount = std::min (limit, static_cast<int> (tcb->m_ssThresh - tcb->m_bytesInFlight));
     }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/internet/model/tcp-rate-ops.cc ns-3.32/src/internet/model/tcp-rate-ops.cc
--- ns-3.31/src/internet/model/tcp-rate-ops.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/internet/model/tcp-rate-ops.cc	2020-10-06 15:35:43.000000000 -0700
@@ -178,11 +178,11 @@
   if (m_rateSample.m_priorDelivered == 0
       || skbInfo.m_delivered > m_rateSample.m_priorDelivered)
     {
+      m_rateSample.m_ackElapsed       = Simulator::Now () - m_rateSample.m_priorTime;
       m_rateSample.m_priorDelivered   = skbInfo.m_delivered;
       m_rateSample.m_priorTime        = skbInfo.m_deliveredTime;
       m_rateSample.m_isAppLimited     = skbInfo.m_isAppLimited;
       m_rateSample.m_sendElapsed      = skb->GetLastSent () - skbInfo.m_firstSent;
-      m_rateSample.m_ackElapsed       = Simulator::Now () - skbInfo.m_deliveredTime;
 
       m_rateSampleTrace (m_rateSample);
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/internet/model/tcp-socket-base.cc ns-3.32/src/internet/model/tcp-socket-base.cc
--- ns-3.31/src/internet/model/tcp-socket-base.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/internet/model/tcp-socket-base.cc	2020-10-06 15:35:43.000000000 -0700
@@ -196,6 +196,10 @@
                      "Highest ack received from peer",
                      MakeTraceSourceAccessor (&TcpSocketBase::m_highRxAckMark),
                      "ns3::TracedValueCallback::SequenceNumber32")
+    .AddTraceSource ("PacingRate",
+                     "The current TCP pacing rate",
+                     MakeTraceSourceAccessor (&TcpSocketBase::m_pacingRateTrace),
+                     "ns3::TracedValueCallback::DataRate")
     .AddTraceSource ("CongestionWindow",
                      "The TCP connection's congestion window",
                      MakeTraceSourceAccessor (&TcpSocketBase::m_cWndTrace),
@@ -249,13 +253,17 @@
 
   m_tcb->m_rxBuffer = CreateObject<TcpRxBuffer> ();
 
-  m_tcb->m_currentPacingRate = m_tcb->m_maxPacingRate;
+  m_tcb->m_pacingRate = m_tcb->m_maxPacingRate;
   m_pacingTimer.SetFunction (&TcpSocketBase::NotifyPacingPerformed, this);
 
   m_tcb->m_sendEmptyPacketCallback = MakeCallback (&TcpSocketBase::SendEmptyPacket, this);
 
   bool ok;
 
+  ok = m_tcb->TraceConnectWithoutContext ("PacingRate",
+                                          MakeCallback (&TcpSocketBase::UpdatePacingRateTrace, this));
+  NS_ASSERT (ok == true);
+
   ok = m_tcb->TraceConnectWithoutContext ("CongestionWindow",
                                           MakeCallback (&TcpSocketBase::UpdateCwnd, this));
   NS_ASSERT (ok == true);
@@ -365,7 +373,7 @@
   m_tcb = CopyObject (sock.m_tcb);
   m_tcb->m_rxBuffer = CopyObject (sock.m_tcb->m_rxBuffer);
 
-  m_tcb->m_currentPacingRate = m_tcb->m_maxPacingRate;
+  m_tcb->m_pacingRate = m_tcb->m_maxPacingRate;
   m_pacingTimer.SetFunction (&TcpSocketBase::NotifyPacingPerformed, this);
 
   if (sock.m_congestionControl)
@@ -387,6 +395,9 @@
 
   bool ok;
 
+  ok = m_tcb->TraceConnectWithoutContext ("PacingRate",
+                                          MakeCallback (&TcpSocketBase::UpdatePacingRateTrace, this));
+
   ok = m_tcb->TraceConnectWithoutContext ("CongestionWindow",
                                           MakeCallback (&TcpSocketBase::UpdateCwnd, this));
   NS_ASSERT (ok == true);
@@ -1304,6 +1315,7 @@
       else
         {
           m_sackEnabled = false;
+          m_txBuffer->SetSackEnabled (false);
         }
 
       // When receiving a <SYN> or <SYN-ACK> we should adapt TS to the other end
@@ -1733,6 +1745,32 @@
 
   SequenceNumber32 ackNumber = tcpHeader.GetAckNumber ();
   SequenceNumber32 oldHeadSequence = m_txBuffer->HeadSequence ();
+
+  if (ackNumber < oldHeadSequence)
+    {
+      NS_LOG_DEBUG ("Possibly received a stale ACK (ack number < head sequence)");
+      // If there is any data piggybacked, store it into m_rxBuffer
+      if (packet->GetSize () > 0)
+        {
+          ReceivedData (packet, tcpHeader);
+        }
+      return;
+    }
+  if ((ackNumber > oldHeadSequence) && (ackNumber < m_recover)
+                                    && (m_tcb->m_congState == TcpSocketState::CA_RECOVERY))
+    {
+      uint32_t segAcked = (ackNumber - oldHeadSequence)/m_tcb->m_segmentSize;
+      for (uint32_t i = 0; i < segAcked; i++)
+        {
+          if (m_txBuffer->IsRetransmittedDataAcked (ackNumber - (i * m_tcb->m_segmentSize)))
+            {
+              m_tcb->m_isRetransDataAcked = true;
+              NS_LOG_DEBUG ("Ack Number " << ackNumber <<
+                            "is ACK of retransmitted packet.");
+            }
+        }
+    }
+
   m_txBuffer->DiscardUpTo (ackNumber, MakeCallback (&TcpRateOps::SkbDelivered, m_rateOps));
 
   uint32_t currentDelivered = static_cast<uint32_t> (m_rateOps->GetConnectionRate ().m_delivered - previousDelivered);
@@ -1759,6 +1797,7 @@
   // RFC 6675 Section 5: 2nd, 3rd paragraph and point (A), (B) implementation
   // are inside the function ProcessAck
   ProcessAck (ackNumber, (bytesSacked > 0), currentDelivered, oldHeadSequence);
+  m_tcb->m_isRetransDataAcked = false;
 
   if (m_congestionControl->HasCongControl ())
     {
@@ -1904,19 +1943,21 @@
               NS_LOG_INFO ("Partial ACK. Manually setting head as lost");
               m_txBuffer->MarkHeadAsLost ();
             }
-          else
-            {
-              // We received a partial ACK, if we retransmitted this segment
-              // probably is better to retransmit it
-              m_txBuffer->DeleteRetransmittedFlagFromHead ();
-            }
-          DoRetransmit (); // Assume the next seq is lost. Retransmit lost packet
-          m_tcb->m_cWndInfl = SafeSubtraction (m_tcb->m_cWndInfl, bytesAcked);
+
+          // Before retransmitting the packet perform DoRecovery and check if
+          // there is available window
           if (!m_congestionControl->HasCongControl () && segsAcked >= 1)
             {
               m_recoveryOps->DoRecovery (m_tcb, currentDelivered);
             }
 
+          // If the packet is already retransmitted do not retransmit it
+          if (!m_txBuffer->IsRetransmittedDataAcked (ackNumber + m_tcb->m_segmentSize))
+            {
+              DoRetransmit (); // Assume the next seq is lost. Retransmit lost packet
+              m_tcb->m_cWndInfl = SafeSubtraction (m_tcb->m_cWndInfl, bytesAcked);
+            }
+
           // This partial ACK acknowledge the fact that one segment has been
           // previously lost and now successfully received. All others have
           // been processed when they come under the form of dupACKs
@@ -2004,7 +2045,8 @@
               // Recalculate the segs acked, that are from m_recover to ackNumber
               // (which are the ones we have not passed to PktsAcked and that
               // can increase cWnd)
-              segsAcked = static_cast<uint32_t>(ackNumber - m_recover) / m_tcb->m_segmentSize;
+              // TODO:  check consistency for dynamic segment size
+              segsAcked = static_cast<uint32_t>(ackNumber - oldHeadSequence) / m_tcb->m_segmentSize;
               m_congestionControl->PktsAcked (m_tcb, segsAcked, m_tcb->m_lastRtt);
               m_congestionControl->CwndEvent (m_tcb, TcpSocketState::CA_EVENT_COMPLETE_CWR);
               m_congestionControl->CongestionStateSet (m_tcb, TcpSocketState::CA_OPEN);
@@ -2047,7 +2089,7 @@
               NS_LOG_DEBUG ("Leaving Fast Recovery; BytesInFlight() = " <<
                             BytesInFlight () << "; cWnd = " << m_tcb->m_cWnd);
             }
-          else
+          if (m_tcb->m_congState == TcpSocketState::CA_OPEN)
             {
               m_congestionControl->IncreaseWindow (m_tcb, segsAcked);
 
@@ -2062,6 +2104,11 @@
             }
         }
     }
+  // Update the pacing rate, since m_congestionControl->IncreaseWindow() or
+  // m_congestionControl->PktsAcked () may change m_tcb->m_cWnd
+  // Make sure that control reaches the end of this function and there is no
+  // return in between
+  UpdatePacingRate ();
 }
 
 /* Received a packet upon LISTEN state. */
@@ -2153,6 +2200,8 @@
       m_tcb->m_rxBuffer->SetNextRxSequence (tcpHeader.GetSequenceNumber () + SequenceNumber32 (1));
       m_tcb->m_highTxMark = ++m_tcb->m_nextTxSequence;
       m_txBuffer->SetHeadSequence (m_tcb->m_nextTxSequence);
+      // Before sending packets, update the pacing rate based on RTT measurement so far 
+      UpdatePacingRate ();
       SendEmptyPacket (TcpHeader::ACK);
 
       /* Check if we received an ECN SYN-ACK packet. Change the ECN state of sender to ECN_IDLE if receiver has sent an ECN SYN-ACK
@@ -2226,6 +2275,8 @@
       m_delAckCount = m_delAckMaxCount;
       NotifyNewConnectionCreated (this, fromAddress);
       ReceivedAck (packet, tcpHeader);
+      // Update the pacing rate based on RTT measurement so far
+      UpdatePacingRate ();
       // As this connection is established, the socket is available to send data now
       if (GetTxAvailable () > 0)
         {
@@ -2937,20 +2988,24 @@
   // peer when it is not retransmission.
   NS_ASSERT (isRetransmission || ((m_highRxAckMark + SequenceNumber32 (m_rWnd)) >= (seq + SequenceNumber32 (maxSize))));
 
-  if (m_tcb->m_pacing)
+  if (IsPacingEnabled ())
     {
       NS_LOG_INFO ("Pacing is enabled");
       if (m_pacingTimer.IsExpired ())
         {
-          NS_LOG_DEBUG ("Current Pacing Rate " << m_tcb->m_currentPacingRate);
-          NS_LOG_DEBUG ("Timer is in expired state, activate it " << m_tcb->m_currentPacingRate.CalculateBytesTxTime (sz));
-          m_pacingTimer.Schedule (m_tcb->m_currentPacingRate.CalculateBytesTxTime (sz));
+          NS_LOG_DEBUG ("Current Pacing Rate " << m_tcb->m_pacingRate);
+          NS_LOG_DEBUG ("Timer is in expired state, activate it " << m_tcb->m_pacingRate.Get ().CalculateBytesTxTime (sz));
+          m_pacingTimer.Schedule (m_tcb->m_pacingRate.Get ().CalculateBytesTxTime (sz));
         }
       else
         {
           NS_LOG_INFO ("Timer is already in running state");
         }
     }
+  else
+    {
+      NS_LOG_INFO ("Pacing is disabled");
+    }
 
   if (withAck)
     {
@@ -2965,6 +3020,7 @@
       m_congestionControl->ReduceCwnd (m_tcb);
       m_tcb->m_ssThresh = m_tcb->m_cWnd;
       m_tcb->m_cWndInfl = m_tcb->m_cWnd;
+      UpdatePacingRate ();
       flags |= TcpHeader::CWR;
       m_ecnCWRSeq = seq;
       NS_LOG_DEBUG (TcpSocketState::EcnStateName[m_tcb->m_ecnState] << " -> ECN_CWR_SENT");
@@ -3103,7 +3159,7 @@
   // else branch to control silly window syndrome and Nagle)
   while (availableWindow > 0)
     {
-      if (m_tcb->m_pacing)
+      if (IsPacingEnabled ())
         {
           NS_LOG_INFO ("Pacing is enabled");
           if (m_pacingTimer.IsRunning ())
@@ -3185,7 +3241,6 @@
               m_congestionControl->CwndEvent (m_tcb, TcpSocketState::CA_EVENT_TX_START);
             }
           uint32_t sz = SendDataPacket (m_tcb->m_nextTxSequence, s, withAck);
-          m_tcb->m_nextTxSequence += sz;
 
           NS_LOG_LOGIC (" rxwin " << m_rWnd <<
                         " segsize " << m_tcb->m_segmentSize <<
@@ -3197,15 +3252,16 @@
                         " total unAck: " << UnAckDataCount () <<
                         " sent seq " << m_tcb->m_nextTxSequence <<
                         " size " << sz);
+          m_tcb->m_nextTxSequence += sz;
           ++nPacketsSent;
-          if (m_tcb->m_pacing)
+          if (IsPacingEnabled ())
             {
               NS_LOG_INFO ("Pacing is enabled");
               if (m_pacingTimer.IsExpired ())
                 {
-                  NS_LOG_DEBUG ("Current Pacing Rate " << m_tcb->m_currentPacingRate);
-                  NS_LOG_DEBUG ("Timer is in expired state, activate it " << m_tcb->m_currentPacingRate.CalculateBytesTxTime (sz));
-                  m_pacingTimer.Schedule (m_tcb->m_currentPacingRate.CalculateBytesTxTime (sz));
+                  NS_LOG_DEBUG ("Current Pacing Rate " << m_tcb->m_pacingRate);
+                  NS_LOG_DEBUG ("Timer is in expired state, activate it " << m_tcb->m_pacingRate.Get ().CalculateBytesTxTime (sz));
+                  m_pacingTimer.Schedule (m_tcb->m_pacingRate.Get ().CalculateBytesTxTime (sz));
                   break;
                 }
             }
@@ -4236,6 +4292,12 @@
 }
 
 void
+TcpSocketBase::UpdatePacingRateTrace (DataRate oldValue, DataRate newValue)
+{
+  m_pacingRateTrace (oldValue, newValue);
+}
+
+void
 TcpSocketBase::UpdateCwnd (uint32_t oldValue, uint32_t newValue)
 {
   m_cWndTrace (oldValue, newValue);
@@ -4333,6 +4395,89 @@
   SendPendingData (m_connected);
 }
 
+bool
+TcpSocketBase::IsPacingEnabled (void) const
+{
+  if (!m_tcb->m_pacing)
+    {
+      return false;
+    }
+  else
+    {
+      if (m_tcb->m_paceInitialWindow)
+        {
+          return true;
+        }
+      SequenceNumber32 highTxMark = m_tcb->m_highTxMark; // cast traced value
+      if (highTxMark.GetValue () > (GetInitialCwnd () * m_tcb->m_segmentSize))
+        {
+          return true;
+        }
+    }
+  return false;
+}
+
+void
+TcpSocketBase::UpdatePacingRate (void)
+{
+  NS_LOG_FUNCTION (this << m_tcb);
+
+  // According to Linux, set base pacing rate to (cwnd * mss) / srtt
+  //
+  // In (early) slow start, multiply base by the slow start factor.
+  // In late slow start and congestion avoidance, multiply base by
+  // the congestion avoidance factor.
+  // Comment from Linux code regarding early/late slow start:
+  // Normal Slow Start condition is (tp->snd_cwnd < tp->snd_ssthresh)
+  // If snd_cwnd >= (tp->snd_ssthresh / 2), we are approaching
+  // end of slow start and should slow down.
+
+  // Similar to Linux, do not update pacing rate here if the
+  // congestion control implements TcpCongestionOps::CongControl ()
+  if (m_congestionControl->HasCongControl () || !m_tcb->m_pacing) return;
+
+  double factor;
+  if (m_tcb->m_cWnd < m_tcb->m_ssThresh/2)
+    {
+      NS_LOG_DEBUG ("Pacing according to slow start factor; " << m_tcb->m_cWnd << " " << m_tcb->m_ssThresh);
+      factor = static_cast<double> (m_tcb->m_pacingSsRatio)/100;
+    }
+  else
+    {
+      NS_LOG_DEBUG ("Pacing according to congestion avoidance factor; " << m_tcb->m_cWnd << " " << m_tcb->m_ssThresh);
+      factor = static_cast<double> (m_tcb->m_pacingCaRatio)/100;
+    }
+  Time lastRtt = m_tcb->m_lastRtt.Get (); // Get underlying Time value
+  NS_LOG_DEBUG ("Last RTT is " << lastRtt.GetSeconds ());
+  
+  // Multiply by 8 to convert from bytes per second to bits per second
+  DataRate pacingRate ((std::max (m_tcb->m_cWnd, m_tcb->m_bytesInFlight) * 8 * factor) / lastRtt.GetSeconds ());
+  if (pacingRate < m_tcb->m_maxPacingRate)
+    {
+      NS_LOG_DEBUG ("Pacing rate updated to: " << pacingRate);
+      m_tcb->m_pacingRate = pacingRate;
+    }
+  else
+    {
+      NS_LOG_DEBUG ("Pacing capped by max pacing rate: " << m_tcb->m_maxPacingRate);
+      m_tcb->m_pacingRate = m_tcb->m_maxPacingRate;
+    }
+}
+
+void
+TcpSocketBase::SetPacingStatus (bool pacing)
+{
+  NS_LOG_FUNCTION (this << pacing);
+  m_tcb->m_pacing = pacing;
+}
+
+void
+TcpSocketBase::SetPaceInitialWindow (bool paceWindow)
+{
+  NS_LOG_FUNCTION (this << paceWindow);
+  m_tcb->m_paceInitialWindow = paceWindow;
+}
+
 void
 TcpSocketBase::SetUseEcn (TcpSocketState::UseEcn_t useEcn)
 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/internet/model/tcp-socket-base.h ns-3.32/src/internet/model/tcp-socket-base.h
--- ns-3.31/src/internet/model/tcp-socket-base.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/internet/model/tcp-socket-base.h	2020-10-06 15:35:43.000000000 -0700
@@ -318,6 +318,11 @@
   uint32_t GetRetxThresh (void) const { return m_retxThresh; }
 
   /**
+   * \brief Callback pointer for pacing rate trace chaining
+   */
+  TracedCallback<DataRate, DataRate>  m_pacingRateTrace;
+
+  /**
    * \brief Callback pointer for cWnd trace chaining
    */
   TracedCallback<uint32_t, uint32_t> m_cWndTrace;
@@ -363,6 +368,13 @@
   TracedCallback<Time, Time> m_lastRttTrace;
 
   /**
+   * \brief Callback function to hook to TcpSocketState pacing rate
+   * \param oldValue old pacing rate value
+   * \param newValue new pacing rate value
+   */
+  void UpdatePacingRateTrace (DataRate oldValue, DataRate newValue);
+
+  /**
    * \brief Callback function to hook to TcpSocketState congestion window
    * \param oldValue old cWnd value
    * \param newValue new cWnd value
@@ -547,6 +559,18 @@
    */
   void SetUseEcn (TcpSocketState::UseEcn_t useEcn);
 
+  /**
+   * \brief Enable or disable pacing
+   * \param pacing Boolean to enable or disable pacing
+   */
+  void SetPacingStatus (bool pacing);
+
+  /**
+   * \brief Enable or disable pacing of the initial window
+   * \param pacing Boolean to enable or disable pacing of the initial window
+   */
+  void SetPaceInitialWindow (bool paceWindow);
+
   // Necessary implementations of null functions from ns3::Socket
   virtual enum SocketErrno GetErrno (void) const;    // returns m_errno
   virtual enum SocketType GetSocketType (void) const; // returns socket type
@@ -1179,6 +1203,19 @@
   void NotifyPacingPerformed (void);
 
   /**
+   * \brief Return true if packets in the current window should be paced
+   * \return true if pacing is currently enabled
+   */
+  bool IsPacingEnabled (void) const;
+
+  /**
+   * \brief Dynamically update the pacing rate
+   *
+   * \param tcb internal congestion state
+   */
+  void UpdatePacingRate (void);
+
+  /**
    * \brief Add Tags for the Socket
    * \param p Packet
    */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/internet/model/tcp-socket.cc ns-3.32/src/internet/model/tcp-socket.cc
--- ns-3.31/src/internet/model/tcp-socket.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/internet/model/tcp-socket.cc	2020-10-06 15:35:43.000000000 -0700
@@ -73,7 +73,7 @@
                    MakeUintegerChecker<uint32_t> ())
     .AddAttribute ("InitialCwnd",
                    "TCP initial congestion window size (segments)",
-                   UintegerValue (1),
+                   UintegerValue (10),
                    MakeUintegerAccessor (&TcpSocket::GetInitialCwnd,
                                          &TcpSocket::SetInitialCwnd),
                    MakeUintegerChecker<uint32_t> ())
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/internet/model/tcp-socket-state.cc ns-3.32/src/internet/model/tcp-socket-state.cc
--- ns-3.31/src/internet/model/tcp-socket-state.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/internet/model/tcp-socket-state.cc	2020-10-06 15:35:43.000000000 -0700
@@ -36,6 +36,22 @@
                    DataRateValue (DataRate ("4Gb/s")),
                    MakeDataRateAccessor (&TcpSocketState::m_maxPacingRate),
                    MakeDataRateChecker ())
+    .AddAttribute ("PacingSsRatio", "Percent pacing rate increase for slow start conditions",
+                   UintegerValue (200),
+                   MakeUintegerAccessor (&TcpSocketState::m_pacingSsRatio),
+                   MakeUintegerChecker<uint16_t> ())
+    .AddAttribute ("PacingCaRatio", "Percent pacing rate increase for congestion avoidance conditions",
+                   UintegerValue (120),
+                   MakeUintegerAccessor (&TcpSocketState::m_pacingCaRatio),
+                   MakeUintegerChecker<uint16_t> ())
+    .AddAttribute ("PaceInitialWindow", "Perform pacing for initial window of data",
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&TcpSocketState::m_paceInitialWindow),
+                   MakeBooleanChecker ())
+    .AddTraceSource ("PacingRate",
+                     "The current TCP pacing rate",
+                     MakeTraceSourceAccessor (&TcpSocketState::m_pacingRate),
+                     "ns3::TracedValueCallback::DataRate")
     .AddTraceSource ("CongestionWindow",
                      "The TCP connection's congestion window",
                      MakeTraceSourceAccessor (&TcpSocketState::m_cWnd),
@@ -92,7 +108,10 @@
     m_rcvTimestampEchoReply (other.m_rcvTimestampEchoReply),
     m_pacing (other.m_pacing),
     m_maxPacingRate (other.m_maxPacingRate),
-    m_currentPacingRate (other.m_currentPacingRate),
+    m_pacingRate (other.m_pacingRate),
+    m_pacingSsRatio (other.m_pacingSsRatio),
+    m_pacingCaRatio (other.m_pacingCaRatio),
+    m_paceInitialWindow (other.m_paceInitialWindow),
     m_minRtt (other.m_minRtt),
     m_bytesInFlight (other.m_bytesInFlight),
     m_lastRtt (other.m_lastRtt),
